; =======
;  INTRO
; =======
colpf0	equ $d016
colpf1	equ $d017
colpf2	equ $d018
colpf3	equ $d019
colbak	equ $d01a

dst	equ $82
tmp	equ $84
hpos0	equ $86
hpos2	equ $87
scrl	equ $88

star_f	equ $0800
tabx	equ $0900
mask	equ $0a00
taby_lo	equ $0b00
taby_hi	equ $0b80
font	equ $0c00
screen	equ $1000

star_x	equ startab
star_v	equ startab+$80

msxinit	equ $9200
msxplay	equ $920c
;
	org $2100
;
startab	ins "startab.dat"

intro	lda #$01
	sta $244

	ldy #$0f
	sty hpos0
	sty hpos2

	ldx #$00
	txa
_clrmem	sta $1000,x
	inx
	bne _clrmem
	inc _clrmem+2
	dey
	bpl _clrmem

	ldx #$00
	lda #<screen
	ldy #>screen
_gentby	sta taby_lo,x
	pha
	tya
	sta taby_hi,x
	pla
	clc
	adc #$28
	bcc *+3
	iny
	inx
	bpl _gentby

	ldx #$00
	lda #$c0
	clc
_msk	sta mask,x
	ror @
	ror @
	bpl *+5
	clc
	lda #$c0
	inx
	bne _msk

_tabx	txa
	lsr @
	lsr @
	sta tabx,x
	inx
	bne _tabx

	lda #$04
	sta $2c4
	lda #$98
	sta $2c5
	lda #$0c
	sta $2c6

	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1

_genfnt	lda fnt,x
	sta font+$100,x
	clc
	adc fnt,x
	sta font+$200,x
	clc
	adc fnt,x
	sta font,x
	sta font+$300,x
	inx
	bne _genfnt

	ldy #$08
_mov0	lda $9200,x
_mov1	sta $3300,x
	inx
	bne _mov0
	inc _mov0+2
	inc _mov1+2
	dey
	bne _mov0

	ldy #$08
_movmsx	lda msx,x
_movms0	sta $9200,x
	inx
	bne _movmsx
	inc _movmsx+2
	inc _movms0+2
	dey
	bne _movmsx

	lda #$00
	sta $d208
	lda #$03
	sta $d20f

	lda #$00
	jsr msxinit

	lda #>font
	sta $2f4

	lda #<antic
	sta $230
	lda #>antic
	sta $231

;
_intro	lda $2fc
	cmp #$21
	bne _intro2

	ldy #$08
	ldx #$00
_mov2	lda $3300,x
_mov3	sta $9200,x
	inx
	bne _mov2
	inc _mov2+2
	inc _mov3+2
	dey
	bne _mov2

	ldx #$08
	lda #$00
_sndoff	sta $d200,x
	dex
	bpl _sndoff
	jmp trainer

_intro2	ldx #$08
	ldy #$00
_prt	lda title,x
	clc
	adc rotpal,y
	sta $1f18,x
	iny
	dex
	bpl _prt

_bpi	dec hpos0
	lda hpos0
_bp0	cmp #$0b
	bne _hscrl0
_bp1	inc _ant0
_bp2	lda #$0f
	sta hpos0
_hscrl0	sta $d404

	lda _ant0
	bne _hscl0
	lda #$c6
	sta _bpi
	lda #$0b
	sta _bp0+1
	lda #$0f
	sta _bp2+1
	lda #$ee
	sta _bp1

_hscl0	cmp #$10
	bne _vc
	lda #$e6
	sta _bpi
	lda #$10
	sta _bp0+1
	lda #$0c
	sta _bp2+1
	lda #$ce
	sta _bp1

_vc	lda $d40b
	cmp #$4c
	bne _vc

	lda #$34
	sta colpf0
	lda #$fe
	sta colpf1
	lda #$e8
	sta colpf2
	lda #$d4
	sta colpf3

	jsr msxplay

_vc2	lda $d40b
	cmp #$54
	bne _vc2

	lda #$12
	sta colpf0
	lda #$fe
	sta colpf1
	lda #$e8
	sta colpf2
	lda #$14
	sta colpf3

	dec hpos2
	lda hpos2
	cmp #$0b
	bne _hscrl2
	inc scrl
	bne *+4
	inc scrl+1
	lda #$0f
	sta hpos2
_hscrl2	sta $d404

	ldx #$00
	ldy #$00
cpyscrl	lda (scrl),y
	bpl cpscrl2
	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1
	ldy #$00
	beq cpyscrl
cpscrl2	clc
	adc rotpal2,x
	sta $1f80,x
	iny
	inx
	cpx #41
	bne cpyscrl

	lda #$00
	ldx #$27
_clr	sta screen,x
	sta screen+$78,x
	sta screen+$f0,x
	sta screen+$168,x
	sta screen+$1e0,x
	sta screen+$258,x
	sta screen+$2d0,x
	sta screen+$348,x
	sta screen+$3c0,x
	sta screen+$438,x
	sta screen+$4b0,x
	sta screen+$528,x
	sta screen+$5a0,x
	sta screen+$618,x
	sta screen+$690,x
	sta screen+$708,x
	sta screen+$780,x
	sta screen+$7f8,x
	sta screen+$870,x
	sta screen+$8e8,x
	sta screen+$960,x
	sta screen+$9d8,x
	sta screen+$a50,x
	sta screen+$ac8,x
	sta screen+$b40,x
	sta screen+$bb8,x
	sta screen+$c30,x
	sta screen+$ca8,x
	sta screen+$d20,x
	sta screen+$d98,x
	sta screen+$e10,x
	sta screen+$e88,x
	dex
	bpl _clr

; draw starfield
	ldy #$00
	lda #<screen
	sta dst
	lda #>screen
	sta dst+1

_stars	sty tmp
	ldx star_x,y
	ldy tabx,x
	lda mask,x
	ora (dst),y
	sta (dst),y
	ldy tmp
	iny

	sty tmp
	ldx star_x,y
	ldy tabx,x
	lda mask,x
	ora (dst),y
	sta (dst),y
	ldy tmp
	iny

	sty tmp
	ldx star_x,y
	ldy tabx,x
	lda mask,x
	ora (dst),y
	sta (dst),y
	ldy tmp
	iny

	sty tmp
	ldx star_x,y
	ldy tabx,x
	lda mask,x
	ora (dst),y
	sta (dst),y
	ldy tmp

	lda dst
	clc
	adc #$78
	sta dst
	bcc *+4
	inc dst+1
	iny
	bpl _stars

; draw logo
	lda #<[screen+$5af]
	sta _scrbp+1
	lda #>[screen+$5af]
	sta _scrbp+2

	ldx #$00
drwlog	ldy #$00
drwlogo	lda logo,x
	beq *+5
_scrbp	sta screen,y
	iny
	inx
	cpy #$0a
	bne drwlogo
	lda _scrbp+1
	clc
	adc #$28
	sta _scrbp+1
	bcc *+5
	inc _scrbp+2
	cpx #$f0
	bne drwlog

	ldx #$00
_stars1	lda star_f,x
	clc
	adc star_v,x
	sta star_f,x
	bcc _stars0
	inc star_x,x
	lda star_x,x
	cmp #160
	bne _stars0
	lda #$00
	sta star_x,x
_stars0	inx
	bpl _stars1

	lda 20
	and #$01
	bne _end

	lda rotpal2+47
	sta tmp
	ldy rotpal+47
	ldx #46
_rotpal	lda rotpal,x
	sta rotpal+1,x
	lda rotpal2,x
	sta rotpal2+1,x
	dex
	bpl _rotpal
	sty rotpal
	lda tmp
	sta rotpal2

_end	jmp _intro

;

; $20(colpf1) - white, $40(colpf2) - yellow, $60(colpf3) - green, $80(colpf0) - red
rotpal	dta $60,$60,$60,$40,$40,$40,$20,$20,$20,$40,$40,$40,$80,$80,$80,$40,$40,$40,$20,$20,$20,$40,$40,$40
	dta $60,$60,$60,$40,$40,$40,$20,$20,$20,$40,$40,$40,$80,$80,$80,$40,$40,$40,$20,$20,$20,$40,$40,$40

rotpal2	dta $20,$20,$40,$40,$60,$60,$80,$80,$60,$60
	dta $40,$40,$20,$20,$40,$40,$60,$60,$80,$80
	dta $60,$60,$40,$40,$20,$20,$40,$40,$60,$60
	dta $80,$80,$60,$60,$40,$40,$20,$20,$40,$40
	dta $60,$60,$80,$80,$60,$60,$40,$40

scroll	dta d'                                        '
	dta d'ANOTHER PRODS FOR ATARI HACKING TEAM    '
title	dta d'ALLEY CAT'
	dta d' FROM SYNAPSE    TRAINED ON \O[IO[\OO] BY PROBE   '
	dta d'GREETINGS TO   '
	dta d'ABBUC   ANIMKOMIALS   BIT BUSTERS   BLOWJOBB   COSINE   C[P[U[   DIAL   GRAYSCALE   MADTEAM   NEW GENERATION   QUASIMODOS   SATANTRONIC   '
	dta d'SLIGHT   SSG   SWORD   TAQUART   TRISTESSE   ZELAX   '
	dta d'                                        ',$ff

antic	dta $70,$70,$70
	dta $70,$70,$70
	dta $4e,<screen,>screen
	:95 dta $0e
	dta $70,$54
_ant0	dta $08,$1f
	dta $70,$70,$54
	dta $80,$1f
	dta $41,<antic,>antic

logo	ins "logo.dat"
fnt	ins "font.dat"
msx	ins "mntbike.sap"

; =====================
;  GAME&TRAINED&LOADER
; =====================

; title-screen
	org $be54
	ins "ac_ant.dat"

	org $becb
	ins "ac_scr.dat"

	org $2c4
	dta $2a,$1c,$38,$6a,$00

	org $230
	dta $54,$be 

; game data
	org $3b00
pack	ins "alleycat.001"

	run intro

	org $3b00+$4000
	ins "alleycat.002"

; trainer
ant	dta $70,$70,$70
	dta $42,$00,$bf
	dta $41,<ant,>ant

msg	dta d'UNLIMITED CATS?'

trainer	lda #$00
	sta 710
	tax
_clrr	sta $bf00,x
	sta $3000,x
	inx
	bne _clrr

	ldx #$0e
	stx 709
_msg0	lda msg,x
	sta $bf0c,x
	dex
	bpl _msg0
	inx

	lda #$e0
	sta 756

	lda #<ant
	sta $230
	lda #>ant
	sta $231

_key	lda $2fc
	cmp #$2b
	beq _yes
	cmp #$23
	beq _no
	jmp _key

_yes	lda #$ad
	sta $8c5a
	sta $9e5c
	sta $ad5b
	sta $b0b6

_no	ldy #$80
	ldx #$00
_movv	lda pack,x
_movv0	sta $1b00,x
	inx
	bne _movv
	inc _movv+2
	inc _movv0+2
	dey
	bne _movv

	lda #$60
	sta $54
	ldx #$80
	txa
_ac	sta $280,x
	inx
	bne _ac
	lda #$a0
	sta $d407
	lda #$03
	sta $d01d
	lda #$3e
	sta $022f
	lda #$03
	sta $d20f
	lda #$e0
	sta $207
	jmp $932d
