; =======
;  INTRO
; =======
colpf0	equ $d016
colpf1	equ $d017
colpf2	equ $d018
colpf3	equ $d019
colbak	equ $d01a

tmp	equ $80
src	equ $82
dst	equ $84
cycle	equ $86
hpos	equ $87
scrl	equ $88

coltab	equ $0a00
coltab2	equ $0b00
font	equ $0c00
scroll	equ title-40

msxinit	equ $28f7
msxplay	equ $2c8e
;
	org $2000
;
intro	lda #$01
	sta $244
	sta tmp
	ldx #$00
	txa
	ldy #$04
genpal2	sta coltab,x
	pha
	clc
_add	adc #$00
	sta coltab2,y
	pla
	clc
	adc tmp
	bmi genpal0
	cmp #$10
	bne genpal1
genpal0	pha
	bpl _genpl0
	lda _add+1
	clc
	adc #$10
	sta _add+1
_genpl0	lda tmp
	eor #$ff
	clc
	adc #$01
	sta tmp
	pla
	clc
	adc tmp
genpal1	iny
	inx
	bne genpal2

	txa
	ldy #$0d
_clrscr	sta $1000,x
	inx
	bne _clrscr
	inc _clrscr+2
	dey
	bne _clrscr

_genfnt	lda fnt,x
	sta font+$100,x
	clc
	adc fnt,x
	sta font+$200,x
	clc
	adc fnt,x
	sta font,x
	sta font+$300,x
	inx
	bne _genfnt

; antic
	ldx #39
	lda #$0e
_genant	sta antic+7,x
	dex
	bne _genant

; draw logo
	lda #$10
	sta hpos
	sta src+1
	stx src

	lda #$20
	sta dst
	lda #$13
	sta dst+1
	
drwlogo	ldy #$0e
_drwlg	lda logo,x
	sta (src),y
	lda logo+220,x
	sta (dst),y
	inx
	iny
	cpy #$19
	bne _drwlg
	lda src
	clc
	adc #40
	sta src
	bcc *+4
	inc src+1
	lda dst
	clc
	adc #40
	sta dst
	bcc *+4
	inc dst+1
	cpx #220
	bne drwlogo

	lda #$00
	ldx #39
_wspc	sta scroll,x
	sta fnt,x
	dex
	bpl _wspc
	stx fnt+40

	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1

	jsr msxinit

	lda #>font
	sta $2f4

	lda #<antic
	sta $230
	lda #>antic
	sta $231

	sta $2fc

_intro	lda $2fc
	cmp #33
	bne *+5
	jmp trainer

	jsr msxplay

	lda $d40b
	cmp #$17
	bne *-5

	ldx cycle
	ldy cycle
	lda #41
	sta tmp
_setcl	inx
	dey
	lda coltab,x
	sta $d40a
	sta colpf2
	lda coltab2,y
	sta colpf1
	dec tmp
	bne _setcl

	lda cycle
	and #$1f
	tax
	lda sine,x
	sta _scrl
	lda sine2,x
	sta _scrl+1

	ldx #17
_prt	lda aht,x
	clc
	adc rotpal,x
	sta $1800+$0a,x
	dex
	bpl _prt

	ldx #<pal1
	ldy #>pal1
	jsr setpal

	ldx #11
	ldy #$00
_prt2	lda title,x
	clc
	adc rotpal,y
	sta $1828+$0e,x
	iny
	dex
	bpl _prt2

	lda $d40b
	cmp #$47
	bne *-5

	ldx #<pal0
	ldy #>pal1
	jsr setpal

	lda $d40b
	cmp #$4c
	bne *-5

	ldx #<pal2
	ldy #>pal2
	jsr setpal

; do scroll
	dec hpos
	lda hpos
	cmp #$0b
	bne _hscrl
	inc scrl
	bne *+4
	inc scrl+1
	lda #$0f
	sta hpos
_hscrl	sta $d404
	
	ldx #$00
	ldy #$00
cpyscrl	lda (scrl),y
	bpl cpscrl2
	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1
	ldy #$00
	beq cpyscrl
cpscrl2	clc
	adc rotpal,x
	sta $1850,x
	iny
	inx
	cpx #41
	bne cpyscrl
 
	inc cycle

	ldy rotpal+47
	ldx #46
_rotpal	lda rotpal,x
	sta rotpal+1,x
	dex
	bpl _rotpal
	sty rotpal

	jmp _intro

setpal	stx src
	sty src+1
	ldy #$03
_setpal	lda (src),y
	sta colpf0,y
	dey
	bpl _setpal
	rts

; trainer
trainer	ldx #$08
	lda #$00
_off	sta $d200,x
	dex
	bpl _off

	ldx #11
prt0	lda title,x
	sta $188e,x
	dex
	bpl prt0

	ldx #26
prt1	lda train0,x
	sta $18ae,x
	dex
	bpl prt1

	ldx #23
prt2	lda train1,x
	sta $18d6,x
	lda train2,x
	sta $18fe,x
	lda train3,x
	sta $1926,x
	dex
	bpl prt2

	lda #$e0
	sta $2f4

	lda #$00
	sta 710
	sta $90
	sta $91

	lda #<antict
	sta $230
	lda #>antict
	sta $231

	lda #$ff
	sta $2fc

_train	lda $d40b
	bne _train

	ldx #$05
	lda $90
	bne *+4
	ldx #$02

	ldy #$02
_tt0	lda train4,x
	sta $18ef,y
	dex
	dey
	bpl _tt0

	ldx #$05
	lda $91
	bne *+4
	ldx #$02

	ldy #$02
_tt1	lda train4,x
	sta $1917,y
	dex
	dey
	bpl _tt1

	txa
	cmp $2fc
	beq *-3
		
	lda $2fc
	cmp #$1f
	bne _key0
	inc $90
	lda $90
	and #$01
	sta $90

_key0	cmp #$1e
	bne _key1
	inc $91
	lda $91
	and #$01
	sta $91

_key1	cmp #$1a
	bne _tt3
; cheat
	ldx #$ad
	lda $90
	beq *+5
	stx $8568
	lda $91
	beq *+5
	stx $7e40
	jmp greenb

_tt3	lda #$ff
	sta $2fc
	jmp _train

;
antict	dta $70,$70,$70,$70
	dta $42,$80,$18
	dta $02,$70,$02,$02,$02
	dta $41,<antict,>antict

train0	dta d'Intro&Trainer done by pr0be'
train1	dta d'[1] Infinite Lives     -'
train2	dta d'[2] Infinite Ammo      -'
train3	dta d'[3] Start Game          '
train4	dta d'No Yes'

;
rotpal	dta $20,$20,$40,$40,$60,$60,$80,$80,$60,$60
	dta $40,$40,$20,$20,$40,$40,$60,$60,$80,$80
	dta $60,$60,$40,$40,$20,$20,$40,$40,$60,$60
	dta $80,$80,$60,$60,$40,$40,$20,$20,$40,$40
	dta $60,$60,$80,$80,$60,$60,$40,$40

sine	dta $70,$70,$70,$70,$70,$60,$50,$40
	dta $30,$30,$20,$20,$10,$10,$10,$00
	dta $00,$10,$10,$10,$20,$20,$30,$30
	dta $40,$50,$60,$70,$70,$70,$70,$70

sine2	dta $70,$40,$20,$10,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$10,$20,$40,$70

pal0	dta $94,$0e,$1c,$b8
pal1	dta $14,$fe,$3a,$26
pal2	dta $04,$0e,$0a,$06

aht	dta d'ATARI HACKING TEAM'

logo	ins "logo.dat"

title	dta d'GREEN BERET FROM IMAGINE[   TRAINED ON \][\O[]OO^ BY PROBE[   '
	dta d'COME TO THE SILLYVENTURE ]K^[ ATARI PARTY IN THE NORTH SIDE OF POLAND[ INVITATION COMING SOON[   '
        dta d'GREETS FLY OUT TO   ANJ[ AZBEST[ BLACKDOT[ DELY[ DRACON[ GREY[ GEPARD[ JASKIER[ SOLO[ STRYKER[ SWIETY[   CU LATER_'

fnt	ins "font.dat"

antic	dta $70,$70,$70,$70,$70
	dta $4e,$00,$10

	org antic+47
	dta $70,$44,$00,$18
	dta $70,$70,$70,$70,$70
	dta $44,$28,$18
	dta $70,$70
_scrl	dta $70,$70,$55,$50,$18
	dta $41,<antic,>antic

	opt h-
	ins "zero_war.sap"
	opt h+

; ======
;  GAME
; ======
	org $600
; --------
;  depack
; --------
depack	ldy #$00

_depack	lda (src),y
	inc src
	bne *+4
	inc src+1
	cmp #225
	beq _depck2
	sta (dst),y
	inc dst
	bne _depack
	inc dst+1
	bne _depack

_depck2	lda (src),y
	bne _depck3
	lda #225
	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	inc src
	bne _depack
	inc src+1
	bne _depack

_depck3	cmp #$01
	bne *+3
	rts

	tax
	inc src
	bne *+4
	inc src+1
	lda (src),y
_depck4	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	dex
	bne _depck4
	inc src
	bne _depack
	inc src+1
	bne _depack

; depack game
greenb	lda #<pack
	sta src
	lda #>pack
	sta src+1
	lda #$00
	sta dst
	lda #$10
	sta dst+1
	jsr depack

	jmp $4800

	org $5f00
pack	ins "greenb.dat"

	run intro
