colpf0	equ $d016
colpf1	equ $d017
wsync	equ $d40a
vcount	equ $d40b

tmp	equ $80
pal	equ $82
hpos	equ $83
wait	equ $84
hpos2	equ $85
src	equ $88
dst	equ $8a
flg	equ $8c

coltab	equ $1c00
coltab2	equ $1d00
coltab3	equ $1e00
coltab4 equ $1f00

;
	org $2c00
;
font	ins "font.fnt"

; ===================
intro	ldx #$00
	ldy #$04
	lda #$00
gencltb	sta coltab,x
	sta coltab4,y
	pha
	clc
	adc #$80
	sta coltab3,x
	adc #$70
	sta coltab2,y
	pla
_inc	adc #$02
	cmp #$0f
	bcc _gentb
	pha
	lda _inc+1
	eor #$ff
	clc
	adc #$01
	sta _inc+1
	pla
	clc
	adc _inc+1
_gentb	iny
	inx
	bne gencltb

; clear text buffers
	lda #$3f
	ldy #$04
_clr	sta $1000,x
	inx
	bne _clr
	inc _clr+2
	dey
	bne _clr

; set title
	ldx #$04
	ldy #$09
_title	lda title,x
	asl @
	sta $1032,y
	adc #$01
	sta $1033,y
	adc #$1f
	sta $1092,y
	adc #$01
	sta $1093,y
	dey
	dey
	dex
	bpl _title

; set scroll
	inx
	iny
_scroll	lda scroll,x
	bmi _scl1
	asl @
	sta $1130,y
	adc #$01
	sta $1131,y
	adc #$1f
	sta $1230,y
	adc #$01
	sta $1231,y
	iny
	iny
	inx
	bpl _scroll

; generate pallete rotation routine
_scl1	ldy #$0f
genrot	ldx #$0f
_genrot	lda setcl,x
_sv	sta $1400,x
	lda setcl2,x
_sv2	sta $1500,x
	lda setcl3,x
_sv3	sta $1600,x
	dex
	bpl _genrot
	lda _sv+1
	clc
	adc #$10
	sta _sv+1
	sta _sv2+1
	sta _sv3+1
	dey
	bne genrot
	lda #$60
	sta $14f0
	sta $15f0
	sta $16f0

	lda #$0c
	sta hpos
	sta hpos2
	sta $2fc

	lda #>font
	sta $2f4

	lda #<antic
	sta $230
	lda #>antic
	sta $231

;
_intro	dec hpos2
	lda hpos2
	cmp #$0b
	bne _hscrl2
	inc ant3+1
	inc ant4+1
	inc ant5+1
	inc ant6+1
	lda #$0f
	sta hpos2

_hscrl2	lda ant1+1
	cmp #$23
	bne scrl
	inc wait
	bpl _hscrl

scrl	inc hpos
	lda hpos
	cmp #$10
	bne _hscrl
	dec ant2+1
	dec ant1+1
	bne _scl0
	lda #$40
	sta ant1+1
	lda #$a0
	sta ant2+1
_scl0	lda #$00
	sta wait
	lda #$0c
	sta hpos

_hscrl	lda hpos
	sta $d404

	ldx pal
	lda #$0f
	sta tmp

	lda vcount
	cmp #$23
	bne *-5

	jsr $1400

	lda vcount
	cmp #$33
	bne *-5

	lda hpos2
	sta wsync
	sta $d404

	jsr $1500

	lda #$06
	sta wsync
	sta wsync
	sta $d401

	inx
	lda coltab4,x
	ldy coltab,x
	sta wsync
	sta colpf0
	sty colpf1
	jsr $1600

	lda $2fc
	cmp #33
	bne *+5
	jmp start

	inc pal
	jmp _intro

;
antic3	dta $70,$70,$70,$70
	dta $42,<text,>text,$70,$02
	dta $41,$00,$04

; --------
;  depack
; --------
depack	ldy #$00

_depack	lda (src),y
	inc src
	bne *+4
	inc src+1
	cmp #146
	beq _depck2
	sta (dst),y
	inc dst
	bne _depack
	inc dst+1
	bne _depack

_depck2	lda (src),y
	bne _depck3
	lda #146
	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	inc src
	bne _depack
	inc src+1
	bne _depack

_depck3	cmp #$01
	bne *+3
	rts

	tax
	inc src
	bne *+4
	inc src+1
	lda (src),y
_depck4	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	dex
	bne _depck4
	inc src
	bne _depack
	inc src+1
	bne _depack

; depack game
	lda #<pack1
	sta src
	lda #>pack1
	sta src+1
	lda #$00
	sta dst
	lda #$0b
	sta dst+1
	jsr $040c

	lda #$00
	sta src
	sta dst
	lda #$05
	sta src+1
	lda #$b4
	sta dst+1
	jsr $040c

; loadder(org)
	ldx #$00
	txa
_fill	sta $0a00,x
	inx
	bne _fill

	lda #$80
	sta $0a80
	sta $0a85

	stx $0a
	stx $0c
	stx $02
	lda #$10
	sta $0b
	sta $0d
	sta $03

; cheat
	lda flg
	cmp #$39
	bne _start

	ldx #$07
_cht	lda $04c1,x
	sta $0100,x
	dex
	bpl _cht

	lda #$20
	sta $1a77
	lda #$00
	sta $1a78
	lda #$01
	sta $1a79

_start	jmp $1000

cheat	dta $c0,$00,$f0,$03,$38,$e5,$f0,$60

; -------
;  start
; -------
start	lda #$00
	sta 559
	lda #$e0
	sta $2f4

	ldy #$06	
	ldx #$00
mov1	lda pack0,x
mov2	sta $0500,x
	inx
	bne mov1
	inc mov1+2
	inc mov2+2
	dey
	bne mov1

mov3	lda antic3,x
	sta $0400,x
	inx
	bne mov3
	
	lda #$00
	sta $2c6
	sta $230
	lda #$04
	sta $231

	lda #34
	sta 559

	lda #$ff
	sta 764

_key	lda 764
	cmp #$ff
	beq _key

	ldy #$2e
	cmp #$2b
	bne _ptmp
	ldy #$39

_ptmp	sty text+66
	sty flg
	jmp $45b

text	dta d'       NINJA (c) 1986 MASTERTRONIC      '
	dta d'     IMMORTALITY   (Y/N)?               '

antic	dta $70,$70,$70,$70,$70,$70,$70,$70
ant1	dta $54,$40,$10
ant2	dta $54,$a0,$10
	dta $70,$70
ant3	dta $54,$00,$11
ant4	dta $54,$00,$12
ant5	dta $54,$00,$12
ant6	dta $54,$00,$11
	dta $41,<antic,>antic

setcl	inx
	lda coltab2,x
	ldy coltab,x
	sta wsync
	sta colpf0
	sty colpf1

setcl2	inx
	lda coltab2,x
	ldy coltab3,x
	sta wsync
	sta colpf0
	sty colpf1

setcl3	inx
	lda coltab4,x
	ldy coltab,x
	sta wsync
	sta colpf0
	sty colpf1

title	dta $2d,$28,$2d,$29,$20,$ff

scroll	dta $08,$2e,$0b,$0c,$27,$24,$01,$24,$0c,$28,$03,$0c,$28,$02
	dta $0a,$0a,$0a,$0c,$2f,$01,$2e,$21,$20,$21,$2b,$08
	dta $0c,$03,$27,$24,$0c,$25,$28,$01,$02,$03,$0c
	dta $05,$24,$01,$02,$28,$2e,$2d,$0c,$2e,$25,$0c,$03,$27,$28
	dta $02,$0c,$26,$20,$2c,$24,$0c,$06,$28,$03,$27,$0c,$22,$27
	dta $24,$20,$03,$0a,$0a,$0a,$0c,$03,$01,$20,$28,$2d,$24,$23,$0c
	dta $20,$2d,$23,$0c,$2f,$20,$22,$2a,$24,$23,$0c,$21,$08,$0c
	dta $2f,$01,$2e,$21,$24,$0a,$0c,$22,$04,$0b,$ff

;
	org $44e7
pack0	ins "ninja.002"	; $44e7-$4a13
pack1	ins "ninja.000"	; $4a14-$bbff

	run intro

	org pack1+$4000
	ins "ninja.001"
