colpf0	equ $d016
colpf1	equ $d017
colpf2	equ $d018
colpf3	equ $d019
colbak	equ $d01a
wsync	equ $d40a

block	equ $80
hpos	equ $81

msxinit	equ $60cf
msxplay	equ $6193

;
	org $3000
;
intro	lda #$0f
	sta hpos

	ldy #$08
	lda #$00
	tax
_clr	sta $1000,x
	sta $bf00,x
	inx
	bne _clr
	inc _clr+2
	dey
	bne _clr

_drw	ldy #$0c
_drw0	lda logo,x
_sv	sta $1000,y
	inx
	iny
	cpy #$1c
	bne _drw0
	lda _sv+1
	clc
	adc #40
	sta _sv+1
	bcc *+5
	inc _sv+2
	cpx #$50
	bne _drw

	ldx #$00
_cpyfnt	lda font,x
	sta $1508,x
	inx
	bne _cpyfnt

	lda #$14
	sta $2f4

	lda #$fc
	sta $2c4
	lda #$38
	sta $2c5
	lda #$14
	sta $2c6

	lda #$08
	sta block

	ldx #17
_prt1	lda aht,x
	sta $10d3,x
	dex
	bpl _prt1

	stx $2fc

	lda #<antic
	sta $230
	lda #>antic
	sta $231

	lda #$03
	sta $d20f
	lda #$00
	sta $d208
	jsr msxinit

; =======
;  intro
; =======
_intro	lda $d40b
	cmp #$38
	bne _intro

	ldx #$06
_setcl1	lda pal1,x
	sta wsync
	sta colpf2
	dex
	bpl _setcl1

_vc	lda $d40b
	cmp #$5a
	bne _vc

	sta wsync
	lda #$0c
	sta wsync
	sta colbak
	lda #$00
	sta wsync
	sta colbak
	sta wsync

	ldx #$06
_setcl2	lda pal2,x
	sta wsync
	sta colpf2
	dex
	bpl _setcl2

	sta wsync
	sta wsync
	lda #$0c
	sta wsync
	sta colbak
	lda #$00
	sta wsync
	sta colbak

	ldx #$00
	ldy block
_fnt	lda fntblck,y
	sta $1408,x
	iny
	inx
	cpx #$08
	bne _fnt

	lda 20
	and #$01
	beq end
	lda block
	clc
	adc #$08
	cmp #$50
	bne _blck

	ldx #$02
_rotpal	lda $2c4,x
	clc
	adc #$10
	sta $2c4,x
	dex
	bpl _rotpal

	lda #$00
_blck	sta block

end	dec hpos
	lda hpos
	cmp #$0b
	bne _hscrl
	inc scrl+1
	bne *+5
	inc scrl+2
	lda scrl+2
	cmp #>endscrl
	bne _hscr2
	lda scrl+1
	cmp #<endscrl
	bne _hscr2
	lda #<scroll
	sta scrl+1
	lda #>scroll
	sta scrl+2
_hscr2	lda #$0f
	sta hpos
_hscrl	sta $d404

	jsr msxplay

	lda $2fc
	cmp #33
	bne *+5
	jmp trainer

	jmp _intro

;
antic	dta $70,$70,$70,$70,$70,$70,$70
	dta $44,$00,$10
	dta $04,$04,$04,$04,$70
	dta $04,$70,$70,$70,$70,$70,$70,$70,$70
scrl	dta $54,<scroll,>scroll
	dta $41,<antic,>antic

logo	dta $00,$00,$00,$00,$00,$01,$00,$01,$00,$00,$01,$00,$01,$01,$01,$01
	dta $00,$00,$00,$00,$01,$01,$00,$01,$00,$00,$01,$00,$01,$00,$00,$00
	dta $00,$00,$00,$01,$00,$01,$00,$01,$01,$01,$01,$00,$01,$00,$00,$00
	dta $00,$00,$01,$01,$01,$01,$00,$01,$00,$00,$01,$00,$01,$00,$00,$00
	dta $00,$01,$00,$00,$00,$01,$00,$01,$00,$00,$01,$00,$01,$00,$00,$00

font	ins "font.dat"
fntblck	ins "block.dat"

pal1	dta $44,$48,$fc,$fe,$fc,$38,$34
pal2	dta $b4,$b8,$0c,$0e,$0c,$88,$84

aht	dta d'ATARI HACKING TEAM'
scroll	dta d'                                        '
	dta d'PITFALL    TRAINED ON \',$3d
	dta d'[\_[\^ BY PR\BE    GREETINGS TO   '
	dta d'ANALMUX   ANJ   AZBEST   BEWU   BLACKDOT   DELY   DRACON   EPI   ERU   GEPARD   GREG   GREY   JASKIER   LAOO   LEWIS   MIKER   NOID   PIN   RASTER   SACK',$40
	dta d'COSINE   SOLO   STRYKER   SWIETY   TEBE   X',$40
	dta d'RAY   AND OTHER[[['
endscrl	dta d'                                        '

;
trainer	ldx #$08
	lda #$00
_off	sta $d200,x
	dex
	bpl _off

	lda #$e0
	sta $2f4

	lda #<antic2
	sta $230
	lda #>antic2
	sta $231

	ldx #$21
_txt1	lda text1,x
	sta $bf03,x
	dex
	bpl _txt1

	ldx #$15
_txt2	lda text2,x
	sta $bf30,x
	dex
	bpl _txt2
	stx $2fc

_train	jsr setcol
	lda $2fc
	cmp #$ff
	beq _train
	cmp #$2b
	bne train2

; unlimited lives
	lda #$a9
	sta $90a1
	sta $907b

train2	ldx #$15
_txt3	lda text3,x
	sta $bf30,x
	dex
	bpl _txt3
	stx $2fc

_train2 jsr setcol
	lda $2fc
	cmp #$ff
	beq _train2
	cmp #$2b
	bne game

; unlimited time
	lda #$ea
	sta $7746
	sta $7747

game	ldy #$21
	ldx #$00
	stx $22f
_mov	lda pitfall,x
_mov0	sta $5000,x
	inx
	bne _mov
	inc _mov+2
	inc _mov0+2
	dey
	bne _mov

	jmp $7024

;
setcol	lda $d40b
	cmp #$17
	bne setcol

	lda #$10
	sta wsync
	sta colpf2

	ldx #$06
_setcl4	lda pal4,x
	sta wsync
	sta colpf1
	dex
	bpl _setcl4

_vc4	lda $d40b
	cmp #$1f
	bne _vc4

	lda #$90
	sta wsync
	sta colpf2

	ldx #$06
_setcl5	lda pal4,x
	sta wsync
	sta colpf1
	dex
	bpl _setcl5
	rts

;
text1	dta d'PITFALL +2 TRAINED&PACKED BY PR0BE'

text2	dta d'UNLIMITED LIVES? (Y/N)'

text3	dta d' UNLIMITED TIME? (Y/N)'

pal4	dta $04,$08,$0c,$0c,$08,$04,$02

antic2	dta $70,$70,$70,$70,$70
	dta $42,$00,$bf
	dta $70,$02
	dta $41,<antic2,>antic2

;
	org $60cf
	ins "blip.sap"

	org $7000
pitfall	ins "pitfall.dat"

	run intro
