; =======
;  INTRO
; =======
colpf0	equ $d016
colpf1	equ $d017
colpf2	equ $d018
colpf3	equ $d019
colbak	equ $d01a

tmp	equ $80
src	equ $82
dst	equ $84
cycle	equ $86
hpos	equ $87
scrl	equ $88

coltab	equ $0a00
coltab2	equ $0b00
font	equ $0c00
scroll	equ title-40

msxinit	equ $28f7
msxplay	equ $2c8e
;
	org $3500
	dta $41,$00,$35

;
intro	lda #$01
	sta $244
	sta tmp
	ldx #$00
	txa
	ldy #$04
genpal2	sta coltab,x
	pha
	clc
_add	adc #$00
	sta coltab2,y
	pla
	clc
	adc tmp
	bmi genpal0
	cmp #$10
	bne genpal1
genpal0	pha
	bpl _genpl0
	lda _add+1
	clc
	adc #$10
	sta _add+1
_genpl0	lda tmp
	eor #$ff
	clc
	adc #$01
	sta tmp
	pla
	clc
	adc tmp
genpal1	iny
	inx
	bne genpal2

	txa
	ldy #$0d
_clrscr	sta $1000,x
	inx
	bne _clrscr
	inc _clrscr+2
	dey
	bne _clrscr

_genfnt	lda fnt,x
	sta font+$100,x
	clc
	adc fnt,x
	sta font+$200,x
	clc
	adc fnt,x
	sta font,x
	sta font+$300,x
	inx
	bne _genfnt

; antic
	ldx #39
	lda #$0e
_genant	sta antic+7,x
	dex
	bne _genant

; draw logo
	lda #$10
	sta hpos
	sta src+1
	stx src

	lda #$20
	sta dst
	lda #$13
	sta dst+1
	
drwlogo	ldy #$0e
_drwlg	lda logo,x
	sta (src),y
	lda logo+220,x
	sta (dst),y
	inx
	iny
	cpy #$19
	bne _drwlg
	lda src
	clc
	adc #40
	sta src
	bcc *+4
	inc src+1
	lda dst
	clc
	adc #40
	sta dst
	bcc *+4
	inc dst+1
	cpx #220
	bne drwlogo

	lda #$00
	ldx #39
_wspc	sta scroll,x
	sta fnt,x
	dex
	bpl _wspc
	stx fnt+40

	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1

	jsr msxinit

	lda #>font
	sta $2f4

	lda #<antic
	sta $230
	lda #>antic
	sta $231

	sta $2fc

_intro	lda $2fc
	cmp #33
	bne _intro2
	ldx #$08
	lda #$00
_off	sta $d200,x
	dex
	bpl _off
	lda #$e0
	sta $2f4
	jmp trainer

_intro2	jsr msxplay

	lda $d40b
	cmp #$17
	bne *-5

	ldx cycle
	ldy cycle
	lda #41
	sta tmp
_setcl	inx
	dey
	lda coltab,x
	sta $d40a
	sta colpf2
	lda coltab2,y
	sta colpf1
	dec tmp
	bne _setcl

	lda cycle
	and #$1f
	tax
	lda sine,x
	sta _scrl
	lda sine2,x
	sta _scrl+1

	ldx #17
_prt	lda aht,x
	clc
	adc rotpal,x
	sta $1800+$0a,x
	dex
	bpl _prt

	ldx #<pal1
	ldy #>pal1
	jsr setpal

	ldx #19
	ldy #$00
_prt2	lda title,x
	clc
	adc rotpal,y
	sta $1828+$09,x
	iny
	dex
	bpl _prt2

	lda $d40b
	cmp #$47
	bne *-5

	ldx #<pal0
	ldy #>pal1
	jsr setpal

	lda $d40b
	cmp #$4c
	bne *-5

	ldx #<pal2
	ldy #>pal2
	jsr setpal

; do scroll
	dec hpos
	lda hpos
	cmp #$0b
	bne _hscrl
	inc scrl
	bne *+4
	inc scrl+1
	lda #$0f
	sta hpos
_hscrl	sta $d404
	
	ldx #$00
	ldy #$00
cpyscrl	lda (scrl),y
	bpl cpscrl2
	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1
	ldy #$00
	beq cpyscrl
cpscrl2	clc
	adc rotpal,x
	sta $1850,x
	iny
	inx
	cpx #41
	bne cpyscrl
 
	inc cycle

	ldy rotpal+47
	ldx #46
_rotpal	lda rotpal,x
	sta rotpal+1,x
	dex
	bpl _rotpal
	sty rotpal

	jmp _intro

setpal	stx src
	sty src+1
	ldy #$03
_setpal	lda (src),y
	sta colpf0,y
	dey
	bpl _setpal
	rts

;
rotpal	dta $20,$20,$40,$40,$60,$60,$80,$80,$60,$60
	dta $40,$40,$20,$20,$40,$40,$60,$60,$80,$80
	dta $60,$60,$40,$40,$20,$20,$40,$40,$60,$60
	dta $80,$80,$60,$60,$40,$40,$20,$20,$40,$40
	dta $60,$60,$80,$80,$60,$60,$40,$40

sine	dta $70,$70,$70,$70,$70,$60,$50,$40
	dta $30,$30,$20,$20,$10,$10,$10,$00
	dta $00,$10,$10,$10,$20,$20,$30,$30
	dta $40,$50,$60,$70,$70,$70,$70,$70

sine2	dta $70,$40,$20,$10,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$00,$00,$00,$00
	dta $00,$00,$00,$00,$10,$20,$40,$70

pal0	dta $94,$0e,$1c,$b8
pal1	dta $14,$fe,$3a,$26
pal2	dta $04,$0e,$0a,$06

aht	dta d'ATARI HACKING TEAM'

logo	ins "logo.dat"

title	dta d'THE LAST STARFIGHTER[   TRAINED ON \^[\O[]OO^ BY PROBE[   '
	dta d'COME TO THE SILLYVENTURE ]K^[ ATARI PARTY IN THE NORTH SIDE OF POLAND[ INVITATION COMING SOON[   '
        dta d'GREETS FLY OUT TO   ANJ[ AZBEST[ BLACKDOT[ DELY[ DRACON[ GREY[ GEPARD[ JASKIER[ SOLO[ STRYKER[ SWIETY[   CU LATER_'

fnt	ins "font.dat"

antic	dta $70,$70,$70,$70,$70
	dta $4e,$00,$10

	org antic+47
	dta $70,$44,$00,$18
	dta $70,$70,$70,$70,$70
	dta $44,$28,$18
	dta $70,$70
_scrl	dta $70,$70,$55,$50,$18
	dta $41,<antic,>antic

	org $230
	dta $00,$35

	opt h-
	ins "zero_war.sap"
	opt h+

; =========
;  TRAINER
; =========
	org $7800
;
trainer	lda #$00
	sta 710
	sta $c0

	lda #$0a
	sta 709

	lda #<tantic
	sta $230
	lda #>tantic
	sta $231

	ldx #22
_txt0	lda text0,x
	sta $1888,x
	dex
	bpl _txt0

	ldx #$00
	jsr fadein
	jsr fadeout

	ldx #15
_txt1	lda text1,x
	sta $18b3,x
	dex
	bpl _txt1

	ldx #$14
	jsr fadein
	jsr fadeout

	ldx #22
_txt2	lda text2,x
	sta $18d6,x
	dex
	bpl _txt2
	ldx #$1c
	jsr prompt

	ldy #$02
_txt3	lda text6-1,x
	sta $18ee,y
	dex
	dey
	bpl _txt3

	txa
	beq train0
; unlimited energy
	lda #$ea
	sta $a886
	sta $a887

train0	ldx #20
_txt4	lda text3,x
	sta $18ff,x
	dex
	bpl _txt4
	ldx #$24
	jsr prompt

	ldy #$02
_txt5	lda text6-1,x
	sta $1915,y
	dex
	dey
	bpl _txt5
	txa
	beq train1
; infinite bombs
	lda #$60
	sta $a8bd

train1	ldx #28
_txt6	lda text4,x
	sta $1923,x
	dex
	bpl _txt6
	ldx #$2c
	jsr prompt

	ldy #$02
_txt7	lda text6-1,x
	sta $1941,y
	dex
	dey
	bpl _txt7
	txa
	beq train2
; indestructible weapons
	lda #$ad
	sta $996a

train2	ldx #25
_txt8	lda text5,x
	sta $194d,x
	dex
	bpl _txt8
	ldx #$34
	jsr prompt

	ldy #$02
_txt9	lda text6-1,x
	sta $1968,y
	dex
	dey
	bpl _txt9
	txa
	beq train3
; temp cheat
	lda #$a9
	sta $982c

train3	lda 20
	cmp 20
	beq *-2

	dec 709
	bne train3

	jmp $80e2

;
prompt	jsr fadein
	jsr fadeout

_key0	lda $2fc
	cmp #$2b
	beq _yes0
	cmp #$23
	beq _no0
	jmp _key0

_no0	ldx #$03
	bne *+4
_yes0	ldx #$06
	stx $2fc
	rts

fadein	jsr wait
	jsr wait

	inc $c0
	lda $c0
	cmp #$10
	bne fadein
	rts

fadeout	jsr wait
	jsr wait

	dec $c0
	lda $c0
	cmp #$07
	bne fadeout
	lda #$00
	sta $c0
	rts

wait	cpx $d40b
	bne *-3
	lda $c0
	sta $d40a
	sta colpf1
	rts

;
tantic	dta $70,$70,$70
	dta $42,$80,$18,$02,$70
	dta $70,$02,$70,$02,$70,$02,$70,$02
	dta $41,<tantic,>tantic


text0	dta d'THE LAST STARFIGHTER +4'
text1	dta d'TRAINED BY PR0BE'
text2	dta d'UNLIMITED SHIELD  [Y/N]'
text3	dta d'INFINITE BOMBS  [Y/N]'
text4	dta d'INDESTRUCTIBLE WEAPONS  [Y/N]'
text5	dta d'CRITICAL TEMP CHEAT  [Y/N]'
text6	dta d'NO YES'

;
	org $8000
	ins "starf.dat"

	run intro
