; =======
;  INTRO
; =======
colpf0	equ $d016
colpf1	equ $d017
colpf2	equ $d018
colpf3	equ $d019
colbak	equ $d01a

sin	equ $84
tmp	equ $85

sine	equ $0900
coltab	equ $0a00
coltab2	equ $0b00
font	equ $0c00

depack	equ $0a00
;
	org $1900
;
; --------
;  depack
; --------
packer	sta src+1
	stx dst
	sty dst+1	
	ldy #$00

_depack	lda (src),y
	inc src
	bne *+4
	inc src+1
	cmp #227
	beq _depck2
	sta (dst),y
	inc dst
	bne _depack
	inc dst+1
	bne _depack

_depck2	lda (src),y
	bne _depck3
	lda #227
	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	inc src
	bne _depack
	inc src+1
	bne _depack

_depck3	cmp #$01
	bne *+3
	rts

	tax
	inc src
	bne *+4
	inc src+1
	lda (src),y
_depck4	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	dex
	bne _depck4
	inc src
	bne _depack
	inc src+1
	bne _depack

; depack game
_init	sei
	lda #$00
	sta $d40e
	lda #$fe
	sta $d301

	ldx #$00
_movv	lda packer,x
	sta depack,x
	inx
	bne _movv

	jmp depack+$6e

	lda #<pack0
	sta src
	lda #>pack0
	ldx #$00
	ldy #$e4
	jsr depack

	lda #<pack1
	sta src
	lda #>pack1
	ldx #$00
	ldy #$ff
	jsr depack

	lda #<pack2
	sta src
	lda #>pack2
	ldx #$00
	ldy #$dc
	jsr depack

	lda #<pack3
	sta src
	lda #>pack3
	ldx #$00
	ldy #$0b
	jsr depack

	ldx #$00
	ldy #$b4
_mov	lda $be00,x
_mov0	sta $bf00,x
	inx
	bne _mov
	dec depack+$a8
	dec depack+$ab
	dey
	bne _mov

	lda #$ff
	sta $d301
	lda #$40
	sta $d40e
	cli

	jmp $480

intro	ldx #$01
	stx $244
	dex
	txa
	ldy #$0d
_clrscr	sta $0c00,x
	inx
	bne _clrscr
	inc _clrscr+2
	dey
	bne _clrscr

_genfnt	lda fnt,x
	sta font+$100,x
	clc
	adc fnt,x
	sta font+$200,x
	clc
	adc fnt,x
	sta font,x
	sta font+$300,x
	inx
	bne _genfnt

	lda #$02
	sta tmp
	txa
	ldy #$04
genpal2	sta coltab,x
	pha
	clc
_add	adc #$00
	sta coltab2,y
	pla
	clc
	adc tmp
	bmi genpal0
	cmp #$10
	bne genpal1
genpal0	pha
	bpl _genpl0
	lda _add+1
	clc
	adc #$10
	sta _add+1
_genpl0	lda tmp
	eor #$ff
	clc
	adc #$01
	sta tmp
	pla
	clc
	adc tmp
genpal1	iny
	inx
	bne genpal2

; draw logo
	lda #$10
	sta src+1
	lda #$c0
	sta dst
	lda #$13
	sta dst+1
	lda #$00
	sta src

; generate sine
gsin	ldy #$00
	ldx #$0f
_gsin	lda sintab,y
_gsin0	sta sine,y
_gsin1	sta sine+$10,x
	iny
	dex
	bpl _gsin

	lda _gsin0+1
	clc
	adc #$30
	sta _gsin1+1
	sec
	sbc #$10
	sta _gsin0+1
	bne gsin

	inx
; draw logo
drwlogo	ldy #$12
_drwlg	lda logo,x
	sta (src),y
	lda logo+220,x
	sta (dst),y
	inx
	iny
	cpy #$1d
	bne _drwlg
	lda src
	clc
	adc #48
	sta src
	bcc *+4
	inc src+1
	lda dst
	clc
	adc #48
	sta dst
	bcc *+4
	inc dst+1
	cpx #220
	bne drwlogo

	ldx #17
_print	lda aht,x
	sta $178c,x
	dex
	bpl _print

	lda #>font
	sta $2f4
	sta $2fc

	lda #<antic
	sta $230
	lda #>antic
	sta $231

	lda #$22
	sta $22f

_intro	lda $2fc
	cmp #33
	bne *+5
	jmp trainer

	lda $d40b
	cmp #$17
	bne *-5

	ldx sin
	ldy #40
_sine	lda sine,x
	inx
	sta $d40a
	sta $d404
	lda coltab,x
	sta colpf2
	lda coltab2,x
	sta colpf1
	dey
	bne _sine

	txa
	clc
	adc #$88
	tax

	lda $d40b
	cmp #$2f
	bne *-5

	ldy #$06
_setcl	inx
	lda coltab2,x
	sta $d40a
	sta colpf0
	dey
	bpl _setcl

	lda $d40b
	cmp #$40
	bne *-5

	lda #$44
	sta colpf0
	lda #$fe
	sta colpf1
	lda #$aa
	sta colpf2
	lda #$96
	sta colpf3

	lda 20
	and #$01
	beq _intro

	inc sin

	ldx #$04
_print2	lda msg,x
	clc
	adc rotpal,x
	sta $17ba,x
	dex
	bpl _print2

	ldy rotpal+7
	ldx #$06
_rotpal	lda rotpal,x
	sta rotpal+1,x
	dex
	bpl _rotpal
	sty rotpal

	jmp _intro

; trainer
trainer	lda #$e0
	sta $2f4

	ldx #33
_prt1	lda text,x
	sta $1802,x
	dex
	bpl _prt1
	inx
	stx 710

	lda #<antic2
	sta $230
	lda #>antic2
	sta $231

	ldx #21
_prt2	lda text1,x
	sta $1830,x
	dex
	bpl _prt2
	stx $2fc

_key	lda $2fc
	cmp #$ff
	beq _key

	ldy #$2e
	cmp #$2b
	bne _trn
	ldy #$39
; unlimited lives
	lda #$ad
	sta $4846
	sta $4866

_trn	sty $1847

	lda 20
	bne *-2
	sta $244
	sta $22f
	sta $d400

	jmp _init

;
rotpal	dta $20,$40,$60,$80,$80,$60,$40,$20

sintab	dta $00,$01,$01,$01,$02,$02,$02,$02
	dta $03,$03,$03,$03,$03,$04,$04,$04

logo	ins "logo.dat"

fnt	ins "font.dat"

aht	dta d'ATARI HACKING TEAM'

msg	dta d'ZYBEX'

antic	dta $70,$70,$70,$70,$70
	dta $4e,$00,$10
	:39 dta $0e
	dta $70,$04,$70,$70,$70,$70,$04
	dta $41,<antic,>antic

text	dta d'Zybex +1   Packed&Trained by pr0be'
text1	dta d'Unlimited Lives? (Y/N)'

antic2	dta $70,$70,$70
	dta $42,$00,$18
	dta $70,$02
	dta $41,<antic2,>antic2
