colpf0	equ $d016
colpf1	equ $d017
colpf2	equ $d018
colpf3	equ $d019
colbak	equ $d01a
wsync	equ $d40a

adr	equ $80
scrl	equ $82
hpos	equ $84

font	equ $1000
sclbuf	equ $1900
file	equ $2500
msxinit	equ $b490
msxplay	equ $b47e

;
	org $2000

;
intro	ldx #$00
genfnt	lda fnt,x
	sta font+$100,x
	asl @
	sta font+$200,x
	clc
	adc fnt,x
	sta font+$300,x
	sta font,x
	inx
	bne genfnt

	txa
	ldy #$06
_clr	sta $1400,x
	sta $be00,x
	inx
	bne _clr
	inc _clr+2
	dey
	bne _clr

	lda #>font
	sta 756

	lda #<antic
	sta $230
	lda #>antic
	sta $231

	stx 711
	stx adr
	lda #$14
	sta adr+1
	sta 708
	lda #$18
	sta 709
	lda #$1c
	sta 710
	sta hpos

_drwlog	ldy #$11
drwlogo	lda logo,x
	sta (adr),y
	inx
	iny
	cpy #$19
	bne drwlogo
	lda adr
	clc
	adc #$28
	bcc *+4
	inc adr+1
	sta adr
	cpx #$e0
	bne _drwlog

	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1

	lda #$01
	sta $d208
	lda #$03
	sta $d20f

	jsr msxinit
	stx 764

;
_intro	lda $d40b
	cmp #$25
	bne _intro

	ldx #$e3
_pal	lda pal-$e3,x
	sta wsync
	sta colbak
	inx
	bne _pal

	lda 20
	sta colpf0

; scroll
	dec hpos
	lda hpos
	cmp #$0b
	bne _hscrl
	inc scrl
	bne *+4
	inc scrl+1
	lda #$0f
	sta hpos
_hscrl	sta $d404

	ldy #$00
cpyscl	lda (scrl),y
	bpl _cpyscl
	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1
	ldy #$00
	beq cpyscl
_cpyscl	clc
	adc mask,x
	sta sclbuf+2,x
	iny
	inx
	cpx #38
	bne cpyscl

	lda 20
	and #$01
	beq odd

	ldy mask+47
	ldx #46
_rot	lda mask,x
	sta mask+1,x
	dex
	bpl _rot
	sty mask

odd	jsr msxplay

_vc	lda $d40b
	cmp #$60
	bne _vc

	ldx #$03
_setcl	lda coltab,x
	sta colpf0,x
	dex
	bpl _setcl

	lda 764
	cmp #33
	beq *+5
	jmp _intro
	jmp game

;
antic	dta $70,$70,$70,$70,$70,$70
	dta $4e,$00,$14
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e
	dta $00,$44,<aht,>aht
	dta $70,$70,$70,$70,$70,$70
	dta $44,<title,>title
	dta $70,$70,$70,$70,$70,$70
	dta $54,<sclbuf,>sclbuf
	dta $41,<antic,>antic

aht	dta d'           '
	dta $81,$94,$81,$92,$89,$00,$88,$81,$83,$8b,$89,$8e,$87,$00
	dta $94,$85,$81,$8d
title	dta d'                BRUCE LEE'
scroll	dta d'                                      BRUCE LEE    CRACKED BY SCHUPPISOFT    INTRO AND TRAINER DONE BY PROBE    GREETINGS TO'
	dta d'   AZBEST   BORN   CZAJNIK   DRACON   ERU   GEPARD   GREY   JASKIER   NOID   SOLO   STRYKER   SWIETY'
	dta d'                                      '

pal	dta $94,$00,$94,$98,$00,$94,$98,$9c,$00
	dta $94,$98,$9c,$9f,$9f,$af,$af,$ac,$a8
	dta $a4,$00,$ac,$a8,$a4,$00,$a8,$a4,$00
	dta $a4,$00

coltab	dta $04,$06,$0a,$0e

mask	dta $00,$00,$00,$00,$20,$20,$20,$20
	dta $40,$40,$40,$40,$60,$60,$60,$60
	dta $40,$40,$40,$40,$20,$20,$20,$20
	dta $00,$00,$00,$00,$20,$20,$20,$20
	dta $40,$40,$40,$40,$60,$60,$60,$60
	dta $40,$40,$40,$40,$20,$20,$20,$20

_mask	dta $60,$60,$60,$60,$60,$40,$40,$40,$40,$40
	dta $20,$20,$20,$20,$20,$00,$00,$00,$00,$00
	dta $60,$60,$60,$60,$60,$40,$40,$40,$40,$40
	dta $20,$20,$20,$20,$20,$00,$00,$00,$00,$00

logo	dta $00,$01,$50,$15,$01,$51,$50,$00
	dta $00,$01,$91,$19,$01,$91,$a5,$40
	dta $00,$01,$d1,$1d,$01,$d1,$ea,$95
	dta $00,$01,$91,$19,$01,$91,$aa,$a9
	dta $00,$06,$41,$19,$01,$91,$5a,$ad
	dta $00,$06,$45,$19,$01,$90,$05,$69
	dta $00,$06,$45,$19,$01,$91,$40,$15
	dta $00,$06,$45,$19,$01,$91,$50,$00
	dta $00,$19,$05,$19,$01,$91,$90,$00
	dta $00,$19,$19,$19,$01,$91,$90,$00
	dta $00,$19,$19,$19,$01,$91,$90,$00
	dta $00,$19,$19,$15,$55,$51,$90,$00
	dta $00,$64,$19,$1a,$aa,$91,$90,$00
	dta $00,$54,$19,$1e,$aa,$d1,$90,$00
	dta $00,$65,$59,$1a,$aa,$91,$90,$00
	dta $00,$7a,$95,$15,$55,$51,$90,$00
	dta $01,$6a,$a9,$00,$00,$01,$90,$00
	dta $00,$16,$ad,$15,$01,$51,$90,$00
	dta $01,$01,$69,$19,$01,$91,$90,$00
	dta $01,$50,$15,$19,$01,$91,$90,$00
	dta $06,$40,$01,$19,$01,$91,$90,$00
	dta $06,$40,$10,$19,$01,$91,$90,$00
	dta $06,$40,$15,$19,$01,$91,$90,$00
	dta $06,$40,$19,$19,$01,$91,$90,$00
	dta $19,$00,$19,$19,$01,$91,$90,$00
	dta $1d,$00,$1d,$1d,$01,$d1,$d0,$00
	dta $19,$00,$19,$19,$01,$91,$90,$00
	dta $15,$00,$15,$15,$01,$51,$50,$00

fnt	ins "font.dat"

;
	org file
	ins "brucelee.001"

	run intro

	org file+$4000
	ins "brucelee.002"

;
	org $b478
	ins "msx.dat"

game	ldx #$08
	lda #$00
_off	sta $d200,x
	dex
	bpl _off

	sta 710	

	lda #$e0
	sta $2f4

	lda #<antic2
	sta $230
	lda #>antic2
	sta $231

	ldx #31
_print1	lda msg1,x
	sta $be04,x
	dex
	bpl _print1

	ldx #18
_print2	lda msg2,x
	sta $be32,x
	dex
	bpl _print2

	ldx #20
_print	lda msg,x
	sta $be58,x
	dex
	bpl _print
	stx $2fc

	lda #$0c
	sta 709

trainer	lda $d40b
	cmp #$24
	bne *-5

	lda #$08
	sta wsync
	sta colpf1

	lda $2fc
	cmp #$ff
	beq trainer
	ldy #$39
	cmp #$2b
	beq _run
	lda #$c6
	sta file+$e1a
	ldy #$2e

_run	sty $be6e

	ldy #$78
	ldx #$00
_mov0	lda file,x
_mov1	sta $0400,x
	inx
	bne _mov0
	inc _mov0+2
	inc _mov1+2
	dey
	bne _mov0

	jmp $0400

antic2	dta $70,$70,$70,$70,$70
	dta $42,$00,$be,$02,$70,$02
	dta $41,<antic2,>antic2

msg	dta d'Infinite lives (Y/N)?'
msg1	dta d'BRUCE LEE (c) 1984 DATASOFT INC.'
msg2	dta d'+1 TRAINER BY PR0BE'
