colpf0	equ $d016
colpf1	equ $d017
colpf2	equ $d018
colpf3	equ $d019
colbak	equ $d01a
wsync	equ $d40a

adr	equ $80
scrl	equ $82
hpos	equ $84

font	equ $1000
sclbuf	equ $1900
msxinit	equ $b490
msxplay	equ $b47e

;
	org $321a
;
intro	ldx #$00
genfnt	lda fnt,x
	sta font+$100,x
	asl @
	sta font+$200,x
	clc
	adc fnt,x
	sta font+$300,x
	sta font,x
	inx
	bne genfnt

	txa
	ldy #$06
_clr	sta $1400,x
	inx
	bne _clr
	inc _clr+2
	dey
	bne _clr

	lda #>font
	sta 756

	lda #<antic
	sta $230
	lda #>antic
	sta $231

	stx 711
	stx adr
	lda #$14
	sta adr+1
	sta 708
	lda #$18
	sta 709
	lda #$1c
	sta 710
	sta hpos

_drwlog	ldy #$11
drwlogo	lda logo,x
	sta (adr),y
	inx
	iny
	cpy #$19
	bne drwlogo
	lda adr
	clc
	adc #$28
	bcc *+4
	inc adr+1
	sta adr
	cpx #$e0
	bne _drwlog

	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1

	jsr msxinit
	stx 764

;
_intro	lda $d40b
	cmp #$25
	bne _intro

	ldx #$e3
_pal	lda pal-$e3,x
	sta wsync
	sta colbak
	inx
	bne _pal

	lda 20
	sta colpf0

; scroll
	dec hpos
	lda hpos
	cmp #$0b
	bne _hscrl
	inc scrl
	bne *+4
	inc scrl+1
	lda #$0f
	sta hpos
_hscrl	sta $d404

	ldy #$00
cpyscl	lda (scrl),y
	bpl _cpyscl
	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1
	ldy #$00
	beq cpyscl
_cpyscl	clc
	adc mask,x
	sta sclbuf+2,x
	iny
	inx
	cpx #38
	bne cpyscl

	lda 20
	and #$01
	beq odd

	ldy mask+47
	ldx #46
_rot	lda mask,x
	sta mask+1,x
	dex
	bpl _rot
	sty mask

odd	jsr msxplay

_vc	lda $d40b
	cmp #$60
	bne _vc

	ldx #$03
_setcl	lda coltab,x
	sta colpf0,x
	dex
	bpl _setcl

	lda 764
	cmp #33
	beq *+5
	jmp _intro

;
game	ldx #$08
	lda #$00
_off	sta $d200,x
	dex
	bpl _off

	sta 710	

	lda #<antic2
	sta $230
	lda #>antic2
	sta $231
	lda #$e0
	sta $2f4

;
trainer	lda $d40b
	cmp #$10
	bne trainer

	lda #$0e
	sta colpf1

_vc4	lda $d40b
	cmp #$2c
	bne _vc4

	lda #$0a
	sta colpf1

_vc5	lda $d40b
	cmp #$3c
	bne _vc5

	lda #$06
	sta colpf1

	lda $2fc
	cmp #$1f
	bne _key0

	lda menu3-3
	beq _yes0
	lda #$00
	sta menu3-3
	lda #$2e
	sta menu3-2
	lda #$2f
	sta menu3-1
	jmp _key0

_yes0	lda #$39
	sta menu3-3
	lda #$25
	sta menu3-2
	lda #$33
	sta menu3-1

_key0	lda $2fc
	cmp #$1e
	bne _key1

	lda menu4-3
	beq _yes1
	lda #$00
	sta menu4-3
	lda #$2e
	sta menu4-2
	lda #$2f
	sta menu4-1
	jmp _key1

_yes1	lda #$39
	sta menu4-3
	lda #$25
	sta menu4-2
	lda #$33
	sta menu4-1

_key1	lda $2fc
	cmp #$1a
	bne _key2

	lda menu5-4
	beq _yes2
	lda #$00
	sta menu5-4
	lda #$2e
	sta menu5-3
	lda #$2f
	sta menu5-2
	jmp _key2

_yes2	lda #$39
	sta menu5-4
	lda #$25
	sta menu5-3
	lda #$33
	sta menu5-2

_key2	lda $2fc
	cmp #$0c
	bne _trn
	lda menu3-3
	beq _trn2
	lda #$ac
	sta $3b12
_trn2	lda menu4-3
	beq _trn3
	lda #$ac
	sta $658e
_trn3	lda menu5-4
	beq _trn4
	lda #$ad
	sta $6678
_trn4	jmp start

_trn	lda #$ff
	sta $2fc
	jmp trainer

;
antic	dta $70,$70,$70,$70,$70,$70
	dta $4e,$00,$14
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e
	dta $00,$44,<aht,>aht
	dta $70,$70,$70,$70,$70,$70
	dta $44,<title,>title
	dta $70,$70,$70,$70,$70,$70
	dta $54,<sclbuf,>sclbuf
	dta $41,<antic,>antic

aht	dta d'           '
	dta $81,$94,$81,$92,$89,$00,$88,$81,$83,$8b,$89,$8e,$87,$00
	dta $94,$85,$81,$8d
title	dta d'                DROPZONE'
scroll	dta d'                                      DROPZONE    INTRO AND MULTI[TRAINER DONE BY PROBE    GREETINGS TO'
	dta d'   AZBEST   BORN   CZAJNIK   DRACON   ERU   GEPARD   GREY   JASKIER   NOID   SOLO   STRYKER   SWIETY'
	dta d'                                      '

pal	dta $94,$00,$94,$98,$00,$94,$98,$9c,$00
	dta $94,$98,$9c,$9f,$9f,$af,$af,$ac,$a8
	dta $a4,$00,$ac,$a8,$a4,$00,$a8,$a4,$00
	dta $a4,$00

coltab	dta $04,$06,$0a,$0e

mask	dta $00,$00,$00,$00,$20,$20,$20,$20
	dta $40,$40,$40,$40,$60,$60,$60,$60
	dta $40,$40,$40,$40,$20,$20,$20,$20
	dta $00,$00,$00,$00,$20,$20,$20,$20
	dta $40,$40,$40,$40,$60,$60,$60,$60
	dta $40,$40,$40,$40,$20,$20,$20,$20

_mask	dta $60,$60,$60,$60,$60,$40,$40,$40,$40,$40
	dta $20,$20,$20,$20,$20,$00,$00,$00,$00,$00
	dta $60,$60,$60,$60,$60,$40,$40,$40,$40,$40
	dta $20,$20,$20,$20,$20,$00,$00,$00,$00,$00

logo	dta $00,$01,$50,$15,$01,$51,$50,$00
	dta $00,$01,$91,$19,$01,$91,$a5,$40
	dta $00,$01,$d1,$1d,$01,$d1,$ea,$95
	dta $00,$01,$91,$19,$01,$91,$aa,$a9
	dta $00,$06,$41,$19,$01,$91,$5a,$ad
	dta $00,$06,$45,$19,$01,$90,$05,$69
	dta $00,$06,$45,$19,$01,$91,$40,$15
	dta $00,$06,$45,$19,$01,$91,$50,$00
	dta $00,$19,$05,$19,$01,$91,$90,$00
	dta $00,$19,$19,$19,$01,$91,$90,$00
	dta $00,$19,$19,$19,$01,$91,$90,$00
	dta $00,$19,$19,$15,$55,$51,$90,$00
	dta $00,$64,$19,$1a,$aa,$91,$90,$00
	dta $00,$54,$19,$1e,$aa,$d1,$90,$00
	dta $00,$65,$59,$1a,$aa,$91,$90,$00
	dta $00,$7a,$95,$15,$55,$51,$90,$00
	dta $01,$6a,$a9,$00,$00,$01,$90,$00
	dta $00,$16,$ad,$15,$01,$51,$90,$00
	dta $01,$01,$69,$19,$01,$91,$90,$00
	dta $01,$50,$15,$19,$01,$91,$90,$00
	dta $06,$40,$01,$19,$01,$91,$90,$00
	dta $06,$40,$10,$19,$01,$91,$90,$00
	dta $06,$40,$15,$19,$01,$91,$90,$00
	dta $06,$40,$19,$19,$01,$91,$90,$00
	dta $19,$00,$19,$19,$01,$91,$90,$00
	dta $1d,$00,$1d,$1d,$01,$d1,$d0,$00
	dta $19,$00,$19,$19,$01,$91,$90,$00
	dta $15,$00,$15,$15,$01,$51,$50,$00

fnt	ins "font.dat"

;
pack	ins "dropzone.dat"

menu0	dta d'         DROPZONE MULTI TRAINER'
menu1	dta d'         '
	:22 dta $4d
	dta $00
menu2	dta d'        1-INFINITE LIVES      NO'
menu3	dta d'        2-INFINITE BOMBS      NO'
menu4	dta d'        3-UNLIMITED CLOACK    NO '
menu5	dta d'       PRESS RETURN TO START GAME       '

;
;	org $b478
	ins "msx.dat"

; depack game&run
src	equ $cb
dst	equ $cd
TAG	equ $a3

;
depack	ldy #$00

_depack	lda (src),y
	inc src
	bne *+4
	inc src+1
	cmp #TAG
	beq _depck2
	sta (dst),y
	inc dst
	bne _depack
	inc dst+1
	bne _depack

_depck2	lda (src),y
	bne _depck3
	lda #TAG
	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	inc src
	bne _depack
	inc src+1
	bne _depack

_depck3	cmp #$01
	bne *+3
	rts

	tax
	inc src
	bne *+4
	inc src+1
	lda (src),y
_depck4	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	dex
	bne _depck4
	inc src
	bne _depack
	inc src+1
	bne _depack

; depack game
start	lda #$00
	sta 559
	
	lda #<pack
	sta src
	lda #>pack
	sta src+1
	lda #$00
	sta dst
	lda #$04
	sta dst+1
	jsr depack

	ldy #$8a
	ldx #$ff
_mov	lda $8d00,x
_mov0	sta $b900,x
	dex
	cpx #$ff
	bne _mov
	dec _mov+2
	dec _mov0+2
	dey
	bne _mov

	jmp $3000
;

antic2	dta $70,$70,$70,$70,$70,$70,$70
	dta $42,<menu0,>menu0
	dta $42,<menu1,>menu1
	dta $70
	dta $42,<menu2,>menu2
	dta $42,<menu3,>menu3
	dta $42,<menu4,>menu4
	dta $70,$42,<menu5,>menu5
	dta $41,<antic2,>antic2

;
	run intro
