colpf0	equ $d016
colpf1	equ $d017

adr	equ $d0
hpos	equ $d2
scrl	equ $d3
sclbuf	equ $6ec0
txtbuf	equ $6f00

game	equ $a000
msxinit	equ $b10d
player	equ $b080
;
	org $9000

; * * * * *
;   Intro
; * * * * *
intro	lda #$00
	tax
	ldy #$05
clrmem	sta $6a00,x
	inx
	bne clrmem
	inc clrmem+2
	dey
	bpl clrmem

	stx 764
	stx adr
	lda #$6a
	sta adr+1

	lda #<antic
	sta $230
	lda #>antic
	sta $231

	lda #$04
	sta $2c4
	lda #$08
	sta $2c5
	lda #$0c
	sta $2c6

	sta hpos

	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1

_drwlog	ldy #$11
drwlogo	lda logo,x
	sta (adr),y
	inx
	iny
	cpy #$19
	bne drwlogo
	lda adr
	clc
	adc #$28
	bcc *+4
	inc adr+1
	sta adr
	cpx #$00
	bne _drwlog

	jsr msxinit

;
_intro	jsr player

_vc	lda $d40b
	cmp #$27
	bne _vc

	lda #$00
	sta $d40a
	sta $d018

	sta $d40a

	lda #$06
	sta $d40a
	sta $d017

	lda #$0a
	sta $d40a
	sta $d017

	lda #$0e
	sta $d40a
	sta $d017

	sta $d40a

	lda #$0a
	sta $d40a
	sta $d017

	lda #$06
	sta $d40a
	sta $d017

_vc2	lda $d40b
	cmp #$3b
	bne _vc2

	lda #$00
	sta $d40a
	sta $d017

	lda #$a4
	sta $d40a
	sta $d018

	lda #$a8
	sta $d40a
	sta $d018

	lda #$ac
	sta $d40a
	sta $d018

	lda #$ae
	sta $d40a
	sta $d018
	sta $d40a

	lda #$ac
	sta $d40a
	sta $d018

	lda #$a8
	sta $d40a
	sta $d018

	lda #$a4
	sta $d40a
	sta $d018

; scroll
	lda 20
	and #$01
	beq np

	dec hpos
	lda hpos
	cmp #$0b
	bne _hscrl
	inc scrl
	bne *+4
	inc scrl+1
	lda #$0f
	sta hpos
_hscrl	sta $d404

np	ldx #$00
	ldy #$00
cpyscl	lda (scrl),y
	bpl _cpyscl
	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1
	ldy #$00
	beq cpyscl
_cpyscl	sta sclbuf,x
	iny
	inx
	cpx #41
	bne cpyscl

	lda #$00
	sta $d40a
	sta $d018

_vc3	lda $d40b
	cmp #$58
	bne _vc3

	lda #$04
	sta $d40a
	sta $d017

	lda #$06
	sta $d40a
	sta $d017

	lda #$08
	sta $d40a
	sta $d017

	lda #$0a
	sta $d40a
	sta $d017

	lda #$0c
	sta $d40a
	sta $d017

	lda #$0e
	sta $d40a
	sta $d017

	lda 764
	cmp #33
	beq *+5
	jmp _intro

	lda #$00
	sta $d201
	sta $d203
	sta 710

; * * * * *
;  Trainer
; * * * * *
	lda #$0c
	sta 709

	lda #<antic2
	sta $230
	lda #>antic2
	sta $231

	ldx #23
_print1	lda text1,x
	sta txtbuf+$2,x
	dex
	bpl _print1
	stx 764

_key1	lda 764
	cmp #$ff
	beq _key1

	ldy #$2e
	cmp #$2b
	bne train1

; unlimited life
	ldy #$39

	lda #$ea
	sta $7355

train1	sty txtbuf+$1b

	ldx #23
_print2	lda text2,x
	sta txtbuf+$2a,x
	dex
	bpl _print2
	stx 764

_key2	lda 764
	cmp #$ff
	beq _key2

	ldy #$2e
	cmp #$2b
	bne train2

; unlimited fuel
	ldy #$39

	lda #$ea
	sta $7451
	sta $7452

train2	sty txtbuf+$43

_fade	lda 20
	cmp 20
	beq *-2

	dec 709
	bne _fade

	ldy #31
	ldx #$00
_mov	lda $7000,x
_mov0	sta $a000,x
	inx
	bne _mov
	inc _mov+2
	inc _mov0+2
	dey
	bpl _mov

	jmp game

;
antic	dta $70,$70,$70,$70,$70
	dta $4e,$00,$6a
	:29 dta $0e
	dta $10,$42,<aht,>aht
	dta $70,$70,$70,$70
	dta $42,<title,>title
	dta $70,$70,$70,$70,$70,$70
	dta $52,<sclbuf,>sclbuf
	dta $41,<antic,>antic

antic2	dta $70,$70,$70,$70,$70
	dta $42,<txtbuf,>txtbuf,$02
	dta $41,<antic2,>antic2

logo	dta $00,$3f,$ff,$f0,$3f,$cf,$ff,$f0
	dta $03,$ee,$9d,$50,$30,$f1,$16,$50
	dta $0f,$ba,$6d,$10,$30,$c4,$59,$90
	dta $3e,$e9,$9c,$50,$30,$d1,$66,$90
	dta $3b,$a6,$5d,$10,$30,$c5,$9a,$d0
	dta $ee,$95,$4c,$10,$31,$d6,$55,$50
	dta $fa,$43,$1c,$10,$34,$d9,$40,$00
	dta $e9,$03,$4c,$10,$31,$e5,$00,$00
	dta $e5,$03,$0c,$10,$35,$d9,$00,$00
	dta $d9,$03,$0c,$10,$36,$e9,$00,$00
	dta $e5,$03,$0c,$10,$39,$ed,$00,$00
	dta $d5,$03,$0c,$10,$36,$f9,$00,$00
	dta $d1,$03,$0c,$55,$7a,$ed,$00,$00
	dta $c5,$03,$0d,$16,$6b,$fd,$00,$00
	dta $d1,$ff,$1c,$59,$ae,$f9,$00,$00
	dta $c0,$00,$4d,$66,$bb,$ed,$00,$00
	dta $c0,$01,$1d,$9a,$ef,$f9,$00,$00
	dta $c0,$04,$5e,$55,$5e,$e9,$00,$00
	dta $c0,$11,$6d,$90,$3b,$e5,$00,$00
	dta $c1,$55,$9e,$90,$3e,$d9,$00,$00
	dta $c1,$03,$6e,$d0,$3a,$e5,$00,$00
	dta $c5,$03,$af,$90,$39,$d5,$00,$00
	dta $d1,$03,$be,$d0,$36,$d1,$00,$00
	dta $c5,$03,$ef,$d0,$39,$c5,$00,$00
	dta $d5,$03,$bf,$90,$35,$d1,$00,$00
	dta $d9,$03,$fe,$d0,$34,$c1,$00,$00
	dta $e5,$03,$ef,$90,$31,$c1,$00,$00
	dta $d9,$03,$be,$90,$34,$c1,$00,$00
	dta $e9,$03,$ee,$50,$30,$c1,$00,$00
	dta $d5,$03,$5d,$50,$35,$d5,$00,$00

aht	dta d'           ATARI HACKING TEAM'
title	dta d'               RIVER RAID'
scroll	dta d'                                         RIVER RAID FROM ACTIVISION.   PACKED&TRAINED BY PR0BE.   '
	dta d'GREETINGS TO ALL PEOPLE WHO KEEP THIS GREAT COMPUTER ALIVE!   LOOK OUT FOR OUR OTHER RELEASE...'
	dta d'                                        ',$ff

text1	dta d'UNLIMITED LIVES?   (Y/N)'
text2	dta d'UNLIMITED FUEL?    (Y/N)'

;
	org $7000
	ins "rraid.dat"

;
	opt h-
	ins "abbuc.sap"
	opt h+

	run intro
