; -------
;  INTRO
; -------
colpf0	equ $d016
colpf1	equ $d017
colpf2	equ $d018
colpf3	equ $d019
wsync	equ $d40a
vcount	equ $d40b

src	equ $80
dst	equ $82

tmp	equ $b0
pal	equ $b2
scrl	equ $b3
hpos	equ $b5

screen	equ $1000
coltab0	equ $1500
coltab1	equ $1600
scrlbuf	equ $1700
font	equ $1800

;
	org $2800

; antic
antic	dta $70,$70,$70,$70,$70
	dta $4e,<screen,>screen
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
	dta $0e,$0e,$0e,$0e

	dta $70,$44,$00,$bf
	dta $70,$70,$70,$70,$04
	dta $70,$70,$70,$70,$70,$70,$70,$70,$54,<scrlbuf,>scrlbuf
	dta $41,<antic,>antic

;
intro	ldy #$0d
	sty hpos
	sty $244
	ldx #$00
	stx $22f
	txa
_clrscr	sta screen,x
	sta $bf00,x
	inx
	bne _clrscr
	inc _clrscr+2
	dey
	bne _clrscr

_genfnt	lda fnt,x
	sta font+$100,x
	clc
	adc fnt,x
	sta font+$200,x
	clc
	adc fnt,x
	sta font,x
	sta font+$300,x
	inx
	bne _genfnt

	lda #$02
	sta tmp
	lda #$00
	ldy #$04
genpal2	sta coltab0,x
	pha
	clc
	adc #$20
	sta coltab1,y
	pla
	clc
	adc tmp
	bmi genpal0
	cmp #$10
	bne genpal1
genpal0	pha
	lda tmp
	eor #$ff
	clc
	adc #$01
	sta tmp
	pla
	clc
	adc tmp
genpal1	iny
	inx
	bne genpal2

; draw logo
	lda #<screen+56
	sta tmp
	lda #>screen
	sta tmp+1

	ldx #$00
drwlogo	ldy #$00
_drwlg	lda logo,x
	sta (tmp),y
	inx
	iny
	cpy #8
	bne _drwlg
	lda tmp
	clc
	adc #40
	sta tmp		; next line
	bcc *+4
	inc tmp+1
	cpx #224
	bne drwlogo

	lda #>font
	sta $2f4

	ldx #19
_print	lda aht,x
	sta $bf0a,x
	lda title,x
	sta $bf32,x
	dex
	bpl _print

	stx 764

	lda #<antic
	sta $230
	lda #>antic
	sta $231

	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1

	ldx #<msx
	ldy #>msx
	lda #0
	jsr RASTERMUSICTRACKER

	lda #$22
	sta $22f

;
_vc	lda vcount
	cmp #$18
	bne _vc

	ldx pal
	ldy pal
	lda #$0e
	sta tmp
_setcl	lda coltab0,x
	sta wsync
	sta colpf0
	lda coltab0,y
	sta colpf1
	lda coltab1,x
	sta colpf2
	sta wsync
	inx
	dey
	dec tmp
	bpl _setcl

	inc pal

_vc2	lda vcount
	cmp #$2a
	bne _vc2

	ldy #$06
_setcl2	lda coltab0,x
	clc
	adc #$30
	sta wsync
	sta colpf0
	inx
	dey
	bne _setcl2

_vc3	lda vcount
	cmp #$3e
	bne _vc3

	ldy #$06
_setcl3	lda coltab0,x
	clc
	adc #$80
	sta wsync
	sta colpf0
	inx
	dey
	bne _setcl3

; do scroll
	dec hpos
	lda hpos
	cmp #$0b
	bne _hscrl
	inc scrl
	bne *+4
	inc scrl+1
	lda #$0f
	sta hpos
_hscrl	sta $d404
	
	ldx #$00
cpyscrl	lda (scrl),y
	bpl cpscrl2
	lda #<scroll
	sta scrl
	lda #>scroll
	sta scrl+1
	ldy #$00
	beq cpyscrl
cpscrl2	clc
	adc coltab2,x
	sta scrlbuf,x
	iny
	inx
	cpx #41
	bne cpyscrl

	lda #$14
	sta colpf0
	lda #$1e
	sta colpf1
	lda #$1a
	sta colpf2
	lda #$16
	sta colpf3

	lda 20
	and #$01
	bne _end

	ldy coltab2+47
	ldx #46
_rotpal	lda coltab2,x
	sta coltab2+1,x
	dex
	bpl _rotpal
	sty coltab2

_end	jsr RASTERMUSICTRACKER+3

	lda 764
	cmp #33
	beq *+5
	jmp _vc

;
	jsr RASTERMUSICTRACKER+9

	lda #$e0
	sta $2f4

	lda #$00
	sta 710

	lda #<antic2
	sta $230
	lda #>antic2
	sta $231
	ldx #20
_msg	lda msg,x
	sta $bf88,x
	dex
	bpl _msg
	stx $2fc

_key	lda $2fc
	cmp #$ff
	beq _key

	ldy #$2e
	cmp #$2b
	bne _game
	ldy #$39
	lda #$ad
	sta $4bda
	sta $64ec

_game	sty $bf9e

; depack game & run game
game	lda #<pack
	sta src
	lda #>pack
	sta src+1
	lda #$00
	sta dst
	lda #$30
	sta dst+1
	jsr depack

	lda #$00
	sta 559

	jmp $3000

; ----------
;  depacker
; ----------
depack	ldy #$00

_depack	lda (src),y
	inc src
	bne *+4
	inc src+1
	cmp #156
	beq _depck2
	sta (dst),y
	inc dst
	bne _depack
	inc dst+1
	bne _depack

_depck2	lda (src),y
	bne _depck3
	lda #156
	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	inc src
	bne _depack
	inc src+1
	bne _depack

_depck3	cmp #$01
	bne *+3
	rts

	tax
	inc src
	bne *+4
	inc src+1
	lda (src),y
_depck4	sta (dst),y
	inc dst
	bne *+4
	inc dst+1
	dex
	bne _depck4
	inc src
	bne _depack
	inc src+1
	bne _depack

antic2	dta $70,$70,$70,$70,$70
	dta $42,$80,$bf
	dta $41,<antic2,>antic2

;
logo	ins "ahtlogo.dat"
fnt	ins "font.dat"

aht	dta d' ATARI HACKING TEAM '
title	dta d'        ZORRO       '

scroll	dta d'                                          '
	dta d'ZORRO WAS TRAINED AND PACKED BY PROBE ON O^[O^[O_    JEROEN TEL COVER DONE BY NOID    GREETINGS TO   '
	dta d'NEW GENERATION   ZELAX   TAQUART   GRAYSCALE   TRISTESSE   QUASIMODOS   MADTEAM   SATANTRONIC   '
	dta d'SWORD   SLIGHT   BIT BUSTERS   SSG   DIAL   ABBUC'
        dta d'                                        ',$ff

coltab2	dta $20,$20,$40,$40,$60,$60,$80,$80,$60,$60
	dta $40,$40,$20,$20,$40,$40,$60,$60,$80,$80
	dta $60,$60,$40,$40,$20,$20,$40,$40,$60,$60
	dta $80,$80,$60,$60,$40,$40,$20,$20,$40,$40
	dta $60,$60,$80,$80,$60,$60,$40,$40

msg	dta d'INFINITE LIVES? (Y/N)'

; -----
;  msx
; -----	
STEREOMODE	equ 0

;
	org $3800
	opt h-
msx	ins "msx.rmt"
	opt h+

	icl "rmtplayr.a65"

;
	org $4400
pack	ins "zorro.001"

	run intro

	org $8400
pack0	ins "zorro.002"
